/* Copyright (C) 2018 UPS/IRIT
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* Original authors: Jean-Paul Bodeveix, Mamoun Filali, Regis Spadotti, Guillaume Verdier (UPS/IRIT)
* Modified by: Marc Pantel (INPT/IRIT)
* 
*/
/*
 * Elimine les processus "étendus" (qui contiennent des ports locaux et des priorités)
 * et les remplace par un processus classique et un composant.
 */
package fr.irit.fiacre.etoile.expander ;

import tom.library.sl.* ;
import fiacre.* ;
import fiacre.types.* ;
import java.util.* ;

public class extendedProcess {
	private static boolean tom_equal_term_boolean(boolean t1, boolean t2) {return  t1==t2 ;}private static boolean tom_is_sort_boolean(boolean t) {return  true ;} private static boolean tom_equal_term_char(char t1, char t2) {return  t1==t2 ;}private static boolean tom_is_sort_char(char t) {return  true ;} private static boolean tom_equal_term_String(String t1, String t2) {return  t1.equals(t2) ;}private static boolean tom_is_sort_String(String t) {return  t instanceof String ;} private static boolean tom_equal_term_int(int t1, int t2) {return  t1==t2 ;}private static boolean tom_is_sort_int(int t) {return  true ;} private static boolean tom_equal_term_float(float t1, float t2) {return  t1==t2 ;}private static boolean tom_is_sort_float(float t) {return  true ;} private static boolean tom_equal_term_Observable(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Observable(Object t) {return  (t instanceof fiacre.types.Observable) ;}private static boolean tom_equal_term_Optional_Exp(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Optional_Exp(Object t) {return  (t instanceof fiacre.types.Optional_Exp) ;}private static boolean tom_equal_term_Profile(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Profile(Object t) {return  (t instanceof fiacre.types.Profile) ;}private static boolean tom_equal_term_TypeList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_TypeList(Object t) {return  (t instanceof fiacre.types.TypeList) ;}private static boolean tom_equal_term_Instance(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Instance(Object t) {return  (t instanceof fiacre.types.Instance) ;}private static boolean tom_equal_term_PStatementList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PStatementList(Object t) {return  (t instanceof fiacre.types.PStatementList) ;}private static boolean tom_equal_term_VarAttrList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_VarAttrList(Object t) {return  (t instanceof fiacre.types.VarAttrList) ;}private static boolean tom_equal_term_AffectationList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_AffectationList(Object t) {return  (t instanceof fiacre.types.AffectationList) ;}private static boolean tom_equal_term_ExpList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ExpList(Object t) {return  (t instanceof fiacre.types.ExpList) ;}private static boolean tom_equal_term_PortCompList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortCompList(Object t) {return  (t instanceof fiacre.types.PortCompList) ;}private static boolean tom_equal_term_VarAttr(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_VarAttr(Object t) {return  (t instanceof fiacre.types.VarAttr) ;}private static boolean tom_equal_term_CIndex(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_CIndex(Object t) {return  (t instanceof fiacre.types.CIndex) ;}private static boolean tom_equal_term_Property(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Property(Object t) {return  (t instanceof fiacre.types.Property) ;}private static boolean tom_equal_term_ConditionalStatementList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ConditionalStatementList(Object t) {return  (t instanceof fiacre.types.ConditionalStatementList) ;}private static boolean tom_equal_term_Channel(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Channel(Object t) {return  (t instanceof fiacre.types.Channel) ;}private static boolean tom_equal_term_PortComposition(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortComposition(Object t) {return  (t instanceof fiacre.types.PortComposition) ;}private static boolean tom_equal_term_StringList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_StringList(Object t) {return  (t instanceof fiacre.types.StringList) ;}private static boolean tom_equal_term_VarDecl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_VarDecl(Object t) {return  (t instanceof fiacre.types.VarDecl) ;}private static boolean tom_equal_term_Bound(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Bound(Object t) {return  (t instanceof fiacre.types.Bound) ;}private static boolean tom_equal_term_PortAttr(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortAttr(Object t) {return  (t instanceof fiacre.types.PortAttr) ;}private static boolean tom_equal_term_Declarations(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Declarations(Object t) {return  (t instanceof fiacre.types.Declarations) ;}private static boolean tom_equal_term_PortDecl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortDecl(Object t) {return  (t instanceof fiacre.types.PortDecl) ;}private static boolean tom_equal_term_Optional_Decl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Optional_Decl(Object t) {return  (t instanceof fiacre.types.Optional_Decl) ;}private static boolean tom_equal_term_OPath(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_OPath(Object t) {return  (t instanceof fiacre.types.OPath) ;}private static boolean tom_equal_term_StatementList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_StatementList(Object t) {return  (t instanceof fiacre.types.StatementList) ;}private static boolean tom_equal_term_Item(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Item(Object t) {return  (t instanceof fiacre.types.Item) ;}private static boolean tom_equal_term_VarDecls(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_VarDecls(Object t) {return  (t instanceof fiacre.types.VarDecls) ;}private static boolean tom_equal_term_FieldsDeclList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_FieldsDeclList(Object t) {return  (t instanceof fiacre.types.FieldsDeclList) ;}private static boolean tom_equal_term_PrioDeclList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PrioDeclList(Object t) {return  (t instanceof fiacre.types.PrioDeclList) ;}private static boolean tom_equal_term_Kind(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Kind(Object t) {return  (t instanceof fiacre.types.Kind) ;}private static boolean tom_equal_term_LocPortDecl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_LocPortDecl(Object t) {return  (t instanceof fiacre.types.LocPortDecl) ;}private static boolean tom_equal_term_ParComposition(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ParComposition(Object t) {return  (t instanceof fiacre.types.ParComposition) ;}private static boolean tom_equal_term_Type(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Type(Object t) {return  (t instanceof fiacre.types.Type) ;}private static boolean tom_equal_term_Binop(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Binop(Object t) {return  (t instanceof fiacre.types.Binop) ;}private static boolean tom_equal_term_FieldsDecl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_FieldsDecl(Object t) {return  (t instanceof fiacre.types.FieldsDecl) ;}private static boolean tom_equal_term_LTL(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_LTL(Object t) {return  (t instanceof fiacre.types.LTL) ;}private static boolean tom_equal_term_PortSet(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortSet(Object t) {return  (t instanceof fiacre.types.PortSet) ;}private static boolean tom_equal_term_GenInst(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_GenInst(Object t) {return  (t instanceof fiacre.types.GenInst) ;}private static boolean tom_equal_term_Declaration(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Declaration(Object t) {return  (t instanceof fiacre.types.Declaration) ;}private static boolean tom_equal_term_Arg(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Arg(Object t) {return  (t instanceof fiacre.types.Arg) ;}private static boolean tom_equal_term_Init(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Init(Object t) {return  (t instanceof fiacre.types.Init) ;}private static boolean tom_equal_term_Composition(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Composition(Object t) {return  (t instanceof fiacre.types.Composition) ;}private static boolean tom_equal_term_LPDList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_LPDList(Object t) {return  (t instanceof fiacre.types.LPDList) ;}private static boolean tom_equal_term_ParamDecl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ParamDecl(Object t) {return  (t instanceof fiacre.types.ParamDecl) ;}private static boolean tom_equal_term_ArgList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ArgList(Object t) {return  (t instanceof fiacre.types.ArgList) ;}private static boolean tom_equal_term_Exp(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Exp(Object t) {return  (t instanceof fiacre.types.Exp) ;}private static boolean tom_equal_term_Program_Fiacre(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Program_Fiacre(Object t) {return  (t instanceof fiacre.types.Program_Fiacre) ;}private static boolean tom_equal_term_ParamDecls(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ParamDecls(Object t) {return  (t instanceof fiacre.types.ParamDecls) ;}private static boolean tom_equal_term_Transitions(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Transitions(Object t) {return  (t instanceof fiacre.types.Transitions) ;}private static boolean tom_equal_term_Optional_Statement(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Optional_Statement(Object t) {return  (t instanceof fiacre.types.Optional_Statement) ;}private static boolean tom_equal_term_Statement(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Statement(Object t) {return  (t instanceof fiacre.types.Statement) ;}private static boolean tom_equal_term_Duration(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Duration(Object t) {return  (t instanceof fiacre.types.Duration) ;}private static boolean tom_equal_term_CaseElementList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_CaseElementList(Object t) {return  (t instanceof fiacre.types.CaseElementList) ;}private static boolean tom_equal_term_Unop(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Unop(Object t) {return  (t instanceof fiacre.types.Unop) ;}private static boolean tom_equal_term_PortDecls(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortDecls(Object t) {return  (t instanceof fiacre.types.PortDecls) ;}private static boolean tom_equal_term_GenInsts(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_GenInsts(Object t) {return  (t instanceof fiacre.types.GenInsts) ;}private static boolean tom_equal_term_PortAttrList(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PortAttrList(Object t) {return  (t instanceof fiacre.types.PortAttrList) ;}private static boolean tom_equal_term_Affectation(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Affectation(Object t) {return  (t instanceof fiacre.types.Affectation) ;}private static boolean tom_equal_term_PriorDecl(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_PriorDecl(Object t) {return  (t instanceof fiacre.types.PriorDecl) ;}private static boolean tom_equal_term_ConditionalStatement(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_ConditionalStatement(Object t) {return  (t instanceof fiacre.types.ConditionalStatement) ;}private static boolean tom_equal_term_RPath(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_RPath(Object t) {return  (t instanceof fiacre.types.RPath) ;}private static boolean tom_equal_term_Transition(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Transition(Object t) {return  (t instanceof fiacre.types.Transition) ;}private static boolean tom_equal_term_Infix(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_Infix(Object t) {return  (t instanceof fiacre.types.Infix) ;}private static boolean tom_equal_term_CaseElement(Object t1, Object t2) {return  (t1==t2) ;}private static boolean tom_is_sort_CaseElement(Object t) {return  (t instanceof fiacre.types.CaseElement) ;}private static  fiacre.types.Instance  tom_make_Inst( String  t0,  fiacre.types.GenInsts  t1,  fiacre.types.ExpList  t2,  fiacre.types.ExpList  t3) { return  fiacre.types.instance.Inst.make(t0, t1, t2, t3) ;}private static  fiacre.types.ExpList  tom_make_ConslistExp( fiacre.types.Exp  t0,  fiacre.types.ExpList  t1) { return  fiacre.types.explist.ConslistExp.make(t0, t1) ;}private static  fiacre.types.PortComposition  tom_make_PortComp( fiacre.types.PortSet  t0,  fiacre.types.Composition  t1) { return  fiacre.types.portcomposition.PortComp.make(t0, t1) ;}private static boolean tom_is_fun_sym_ConsstringList( fiacre.types.StringList  t) {return  (t instanceof fiacre.types.stringlist.ConsstringList) ;}private static  String  tom_get_slot_ConsstringList_HeadstringList( fiacre.types.StringList  t) {return  t.getHeadstringList() ;}private static  fiacre.types.StringList  tom_get_slot_ConsstringList_TailstringList( fiacre.types.StringList  t) {return  t.getTailstringList() ;}private static  fiacre.types.Declarations  tom_make_ConsDeclarationList( fiacre.types.Declaration  t0,  fiacre.types.Declarations  t1) { return  fiacre.types.declarations.ConsDeclarationList.make(t0, t1) ;}private static boolean tom_is_fun_sym_PortDec( fiacre.types.PortDecl  t) {return  (t instanceof fiacre.types.portdecl.PortDec) ;}private static  fiacre.types.StringList  tom_get_slot_PortDec_lp( fiacre.types.PortDecl  t) {return  t.getlp() ;}private static  fiacre.types.Type  tom_get_slot_PortDec_type( fiacre.types.PortDecl  t) {return  t.gettype() ;}private static  fiacre.types.PortAttrList  tom_get_slot_PortDec_pal( fiacre.types.PortDecl  t) {return  t.getpal() ;}private static  fiacre.types.Channel  tom_get_slot_PortDec_chan( fiacre.types.PortDecl  t) {return  t.getchan() ;}private static  fiacre.types.Kind  tom_make_OpenKind() { return  fiacre.types.kind.OpenKind.make() ;}private static boolean tom_is_fun_sym_LocPortDec( fiacre.types.LocPortDecl  t) {return  (t instanceof fiacre.types.locportdecl.LocPortDec) ;}private static  fiacre.types.PortDecls  tom_get_slot_LocPortDec_pdl( fiacre.types.LocPortDecl  t) {return  t.getpdl() ;}private static  fiacre.types.Bound  tom_get_slot_LocPortDec_b1( fiacre.types.LocPortDecl  t) {return  t.getb1() ;}private static  fiacre.types.Bound  tom_get_slot_LocPortDec_b2( fiacre.types.LocPortDecl  t) {return  t.getb2() ;}private static  fiacre.types.ParComposition  tom_make_parCompo( fiacre.types.PortSet  t0,  fiacre.types.PortCompList  t1) { return  fiacre.types.parcomposition.parCompo.make(t0, t1) ;}private static  fiacre.types.Type  tom_make_BotType() { return  fiacre.types.type.BotType.make() ;}private static  fiacre.types.PortSet  tom_make_AllPorts() { return  fiacre.types.portset.AllPorts.make() ;}private static  fiacre.types.PortSet  tom_make_SomePorts( fiacre.types.ExpList  t0) { return  fiacre.types.portset.SomePorts.make(t0) ;}private static  fiacre.types.Declaration  tom_make_ProcessDecl( String  t0,  fiacre.types.StringList  t1,  fiacre.types.PortDecls  t2,  fiacre.types.ParamDecls  t3,  fiacre.types.StringList  t4,  fiacre.types.VarDecls  t5,  fiacre.types.Init  t6,  fiacre.types.Transitions  t7) { return  fiacre.types.declaration.ProcessDecl.make(t0, t1, t2, t3, t4, t5, t6, t7) ;}private static boolean tom_is_fun_sym_ExtendedProcessDecl( fiacre.types.Declaration  t) {return  (t instanceof fiacre.types.declaration.ExtendedProcessDecl) ;}private static  String  tom_get_slot_ExtendedProcessDecl_name( fiacre.types.Declaration  t) {return  t.getname() ;}private static  fiacre.types.StringList  tom_get_slot_ExtendedProcessDecl_genericParams( fiacre.types.Declaration  t) {return  t.getgenericParams() ;}private static  fiacre.types.PortDecls  tom_get_slot_ExtendedProcessDecl_ports( fiacre.types.Declaration  t) {return  t.getports() ;}private static  fiacre.types.ParamDecls  tom_get_slot_ExtendedProcessDecl_params( fiacre.types.Declaration  t) {return  t.getparams() ;}private static  fiacre.types.LPDList  tom_get_slot_ExtendedProcessDecl_lpd( fiacre.types.Declaration  t) {return  t.getlpd() ;}private static  fiacre.types.PrioDeclList  tom_get_slot_ExtendedProcessDecl_prios( fiacre.types.Declaration  t) {return  t.getprios() ;}private static  fiacre.types.StringList  tom_get_slot_ExtendedProcessDecl_states( fiacre.types.Declaration  t) {return  t.getstates() ;}private static  fiacre.types.VarDecls  tom_get_slot_ExtendedProcessDecl_vars( fiacre.types.Declaration  t) {return  t.getvars() ;}private static  fiacre.types.Init  tom_get_slot_ExtendedProcessDecl_init( fiacre.types.Declaration  t) {return  t.getinit() ;}private static  fiacre.types.Transitions  tom_get_slot_ExtendedProcessDecl_trans( fiacre.types.Declaration  t) {return  t.gettrans() ;}private static  fiacre.types.Declaration  tom_make_ComponentDecl( String  t0,  fiacre.types.StringList  t1,  fiacre.types.PortDecls  t2,  fiacre.types.ParamDecls  t3,  fiacre.types.VarDecls  t4,  fiacre.types.LPDList  t5,  fiacre.types.PrioDeclList  t6,  fiacre.types.Init  t7,  fiacre.types.Composition  t8) { return  fiacre.types.declaration.ComponentDecl.make(t0, t1, t2, t3, t4, t5, t6, t7, t8) ;}private static boolean tom_is_fun_sym_ValArg( fiacre.types.Arg  t) {return  (t instanceof fiacre.types.arg.ValArg) ;}private static  String  tom_get_slot_ValArg_arg( fiacre.types.Arg  t) {return  t.getarg() ;}private static boolean tom_is_fun_sym_RefArg( fiacre.types.Arg  t) {return  (t instanceof fiacre.types.arg.RefArg) ;}private static  String  tom_get_slot_RefArg_arg( fiacre.types.Arg  t) {return  t.getarg() ;}private static  fiacre.types.Init  tom_make_NoneInit() { return  fiacre.types.init.NoneInit.make() ;}private static  fiacre.types.Composition  tom_make_ParComp( fiacre.types.ParComposition  t0) { return  fiacre.types.composition.ParComp.make(t0) ;}private static  fiacre.types.Composition  tom_make_InstanceComp( fiacre.types.Instance  t0) { return  fiacre.types.composition.InstanceComp.make(t0) ;}private static boolean tom_is_fun_sym_ConslpdList( fiacre.types.LPDList  t) {return  (t instanceof fiacre.types.lpdlist.ConslpdList) ;}private static  fiacre.types.LocPortDecl  tom_get_slot_ConslpdList_HeadlpdList( fiacre.types.LPDList  t) {return  t.getHeadlpdList() ;}private static  fiacre.types.LPDList  tom_get_slot_ConslpdList_TaillpdList( fiacre.types.LPDList  t) {return  t.getTaillpdList() ;}private static boolean tom_is_fun_sym_Paramdec( fiacre.types.ParamDecl  t) {return  (t instanceof fiacre.types.paramdecl.Paramdec) ;}private static  fiacre.types.ArgList  tom_get_slot_Paramdec_lal( fiacre.types.ParamDecl  t) {return  t.getlal() ;}private static  fiacre.types.VarAttrList  tom_get_slot_Paramdec_val( fiacre.types.ParamDecl  t) {return  t.getval() ;}private static  fiacre.types.Type  tom_get_slot_Paramdec_type( fiacre.types.ParamDecl  t) {return  t.gettype() ;}private static boolean tom_is_fun_sym_ConsArList( fiacre.types.ArgList  t) {return  (t instanceof fiacre.types.arglist.ConsArList) ;}private static  fiacre.types.Arg  tom_get_slot_ConsArList_HeadArList( fiacre.types.ArgList  t) {return  t.getHeadArList() ;}private static  fiacre.types.ArgList  tom_get_slot_ConsArList_TailArList( fiacre.types.ArgList  t) {return  t.getTailArList() ;}private static  fiacre.types.Exp  tom_make_RefExp( String  t0,  fiacre.types.Type  t1) { return  fiacre.types.exp.RefExp.make(t0, t1) ;}private static  fiacre.types.Exp  tom_make_IdentExp( String  t0,  fiacre.types.Kind  t1,  fiacre.types.Type  t2) { return  fiacre.types.exp.IdentExp.make(t0, t1, t2) ;}private static boolean tom_is_fun_sym_Prog( fiacre.types.Program_Fiacre  t) {return  (t instanceof fiacre.types.program_fiacre.Prog) ;}private static  fiacre.types.Program_Fiacre  tom_make_Prog( fiacre.types.Declarations  t0,  fiacre.types.Optional_Decl  t1) { return  fiacre.types.program_fiacre.Prog.make(t0, t1) ;}private static  fiacre.types.Declarations  tom_get_slot_Prog_decl( fiacre.types.Program_Fiacre  t) {return  t.getdecl() ;}private static  fiacre.types.Optional_Decl  tom_get_slot_Prog_main( fiacre.types.Program_Fiacre  t) {return  t.getmain() ;}private static boolean tom_is_fun_sym_ConsListParamDecl( fiacre.types.ParamDecls  t) {return  (t instanceof fiacre.types.paramdecls.ConsListParamDecl) ;}private static  fiacre.types.ParamDecl  tom_get_slot_ConsListParamDecl_HeadListParamDecl( fiacre.types.ParamDecls  t) {return  t.getHeadListParamDecl() ;}private static  fiacre.types.ParamDecls  tom_get_slot_ConsListParamDecl_TailListParamDecl( fiacre.types.ParamDecls  t) {return  t.getTailListParamDecl() ;}private static boolean tom_is_fun_sym_ConsListPortDecl( fiacre.types.PortDecls  t) {return  (t instanceof fiacre.types.portdecls.ConsListPortDecl) ;}private static  fiacre.types.PortDecl  tom_get_slot_ConsListPortDecl_HeadListPortDecl( fiacre.types.PortDecls  t) {return  t.getHeadListPortDecl() ;}private static  fiacre.types.PortDecls  tom_get_slot_ConsListPortDecl_TailListPortDecl( fiacre.types.PortDecls  t) {return  t.getTailListPortDecl() ;}private static boolean tom_is_fun_sym_listExp( fiacre.types.ExpList  t) {return  ((t instanceof fiacre.types.explist.ConslistExp) || (t instanceof fiacre.types.explist.EmptylistExp)) ;}private static  fiacre.types.ExpList  tom_empty_list_listExp() { return  fiacre.types.explist.EmptylistExp.make() ;}private static  fiacre.types.ExpList  tom_cons_list_listExp( fiacre.types.Exp  e,  fiacre.types.ExpList  l) { return  fiacre.types.explist.ConslistExp.make(e,l) ;}private static  fiacre.types.Exp  tom_get_head_listExp_ExpList( fiacre.types.ExpList  l) {return  l.getHeadlistExp() ;}private static  fiacre.types.ExpList  tom_get_tail_listExp_ExpList( fiacre.types.ExpList  l) {return  l.getTaillistExp() ;}private static boolean tom_is_empty_listExp_ExpList( fiacre.types.ExpList  l) {return  l.isEmptylistExp() ;}   private static   fiacre.types.ExpList  tom_append_list_listExp( fiacre.types.ExpList l1,  fiacre.types.ExpList  l2) {     if( l1.isEmptylistExp() ) {       return l2;     } else if( l2.isEmptylistExp() ) {       return l1;     } else if(  l1.getTaillistExp() .isEmptylistExp() ) {       return  fiacre.types.explist.ConslistExp.make( l1.getHeadlistExp() ,l2) ;     } else {       return  fiacre.types.explist.ConslistExp.make( l1.getHeadlistExp() ,tom_append_list_listExp( l1.getTaillistExp() ,l2)) ;     }   }   private static   fiacre.types.ExpList  tom_get_slice_listExp( fiacre.types.ExpList  begin,  fiacre.types.ExpList  end, fiacre.types.ExpList  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptylistExp()  ||  (end==tom_empty_list_listExp()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.explist.ConslistExp.make( begin.getHeadlistExp() ,( fiacre.types.ExpList )tom_get_slice_listExp( begin.getTaillistExp() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_PCList( fiacre.types.PortCompList  t) {return  ((t instanceof fiacre.types.portcomplist.ConsPCList) || (t instanceof fiacre.types.portcomplist.EmptyPCList)) ;}private static  fiacre.types.PortCompList  tom_empty_list_PCList() { return  fiacre.types.portcomplist.EmptyPCList.make() ;}private static  fiacre.types.PortCompList  tom_cons_list_PCList( fiacre.types.PortComposition  e,  fiacre.types.PortCompList  l) { return  fiacre.types.portcomplist.ConsPCList.make(e,l) ;}private static  fiacre.types.PortComposition  tom_get_head_PCList_PortCompList( fiacre.types.PortCompList  l) {return  l.getHeadPCList() ;}private static  fiacre.types.PortCompList  tom_get_tail_PCList_PortCompList( fiacre.types.PortCompList  l) {return  l.getTailPCList() ;}private static boolean tom_is_empty_PCList_PortCompList( fiacre.types.PortCompList  l) {return  l.isEmptyPCList() ;}   private static   fiacre.types.PortCompList  tom_append_list_PCList( fiacre.types.PortCompList l1,  fiacre.types.PortCompList  l2) {     if( l1.isEmptyPCList() ) {       return l2;     } else if( l2.isEmptyPCList() ) {       return l1;     } else if(  l1.getTailPCList() .isEmptyPCList() ) {       return  fiacre.types.portcomplist.ConsPCList.make( l1.getHeadPCList() ,l2) ;     } else {       return  fiacre.types.portcomplist.ConsPCList.make( l1.getHeadPCList() ,tom_append_list_PCList( l1.getTailPCList() ,l2)) ;     }   }   private static   fiacre.types.PortCompList  tom_get_slice_PCList( fiacre.types.PortCompList  begin,  fiacre.types.PortCompList  end, fiacre.types.PortCompList  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptyPCList()  ||  (end==tom_empty_list_PCList()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.portcomplist.ConsPCList.make( begin.getHeadPCList() ,( fiacre.types.PortCompList )tom_get_slice_PCList( begin.getTailPCList() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_DeclarationList( fiacre.types.Declarations  t) {return  ((t instanceof fiacre.types.declarations.ConsDeclarationList) || (t instanceof fiacre.types.declarations.EmptyDeclarationList)) ;}private static  fiacre.types.Declarations  tom_empty_list_DeclarationList() { return  fiacre.types.declarations.EmptyDeclarationList.make() ;}private static  fiacre.types.Declarations  tom_cons_list_DeclarationList( fiacre.types.Declaration  e,  fiacre.types.Declarations  l) { return  fiacre.types.declarations.ConsDeclarationList.make(e,l) ;}private static  fiacre.types.Declaration  tom_get_head_DeclarationList_Declarations( fiacre.types.Declarations  l) {return  l.getHeadDeclarationList() ;}private static  fiacre.types.Declarations  tom_get_tail_DeclarationList_Declarations( fiacre.types.Declarations  l) {return  l.getTailDeclarationList() ;}private static boolean tom_is_empty_DeclarationList_Declarations( fiacre.types.Declarations  l) {return  l.isEmptyDeclarationList() ;}   private static   fiacre.types.Declarations  tom_append_list_DeclarationList( fiacre.types.Declarations l1,  fiacre.types.Declarations  l2) {     if( l1.isEmptyDeclarationList() ) {       return l2;     } else if( l2.isEmptyDeclarationList() ) {       return l1;     } else if(  l1.getTailDeclarationList() .isEmptyDeclarationList() ) {       return  fiacre.types.declarations.ConsDeclarationList.make( l1.getHeadDeclarationList() ,l2) ;     } else {       return  fiacre.types.declarations.ConsDeclarationList.make( l1.getHeadDeclarationList() ,tom_append_list_DeclarationList( l1.getTailDeclarationList() ,l2)) ;     }   }   private static   fiacre.types.Declarations  tom_get_slice_DeclarationList( fiacre.types.Declarations  begin,  fiacre.types.Declarations  end, fiacre.types.Declarations  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptyDeclarationList()  ||  (end==tom_empty_list_DeclarationList()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.declarations.ConsDeclarationList.make( begin.getHeadDeclarationList() ,( fiacre.types.Declarations )tom_get_slice_DeclarationList( begin.getTailDeclarationList() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_ListVarDecl( fiacre.types.VarDecls  t) {return  ((t instanceof fiacre.types.vardecls.ConsListVarDecl) || (t instanceof fiacre.types.vardecls.EmptyListVarDecl)) ;}private static  fiacre.types.VarDecls  tom_empty_list_ListVarDecl() { return  fiacre.types.vardecls.EmptyListVarDecl.make() ;}private static  fiacre.types.VarDecls  tom_cons_list_ListVarDecl( fiacre.types.VarDecl  e,  fiacre.types.VarDecls  l) { return  fiacre.types.vardecls.ConsListVarDecl.make(e,l) ;}private static  fiacre.types.VarDecl  tom_get_head_ListVarDecl_VarDecls( fiacre.types.VarDecls  l) {return  l.getHeadListVarDecl() ;}private static  fiacre.types.VarDecls  tom_get_tail_ListVarDecl_VarDecls( fiacre.types.VarDecls  l) {return  l.getTailListVarDecl() ;}private static boolean tom_is_empty_ListVarDecl_VarDecls( fiacre.types.VarDecls  l) {return  l.isEmptyListVarDecl() ;}   private static   fiacre.types.VarDecls  tom_append_list_ListVarDecl( fiacre.types.VarDecls l1,  fiacre.types.VarDecls  l2) {     if( l1.isEmptyListVarDecl() ) {       return l2;     } else if( l2.isEmptyListVarDecl() ) {       return l1;     } else if(  l1.getTailListVarDecl() .isEmptyListVarDecl() ) {       return  fiacre.types.vardecls.ConsListVarDecl.make( l1.getHeadListVarDecl() ,l2) ;     } else {       return  fiacre.types.vardecls.ConsListVarDecl.make( l1.getHeadListVarDecl() ,tom_append_list_ListVarDecl( l1.getTailListVarDecl() ,l2)) ;     }   }   private static   fiacre.types.VarDecls  tom_get_slice_ListVarDecl( fiacre.types.VarDecls  begin,  fiacre.types.VarDecls  end, fiacre.types.VarDecls  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptyListVarDecl()  ||  (end==tom_empty_list_ListVarDecl()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.vardecls.ConsListVarDecl.make( begin.getHeadListVarDecl() ,( fiacre.types.VarDecls )tom_get_slice_ListVarDecl( begin.getTailListVarDecl() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_PrioList( fiacre.types.PrioDeclList  t) {return  ((t instanceof fiacre.types.priodecllist.ConsPrioList) || (t instanceof fiacre.types.priodecllist.EmptyPrioList)) ;}private static  fiacre.types.PrioDeclList  tom_empty_list_PrioList() { return  fiacre.types.priodecllist.EmptyPrioList.make() ;}private static  fiacre.types.PrioDeclList  tom_cons_list_PrioList( fiacre.types.PriorDecl  e,  fiacre.types.PrioDeclList  l) { return  fiacre.types.priodecllist.ConsPrioList.make(e,l) ;}private static  fiacre.types.PriorDecl  tom_get_head_PrioList_PrioDeclList( fiacre.types.PrioDeclList  l) {return  l.getHeadPrioList() ;}private static  fiacre.types.PrioDeclList  tom_get_tail_PrioList_PrioDeclList( fiacre.types.PrioDeclList  l) {return  l.getTailPrioList() ;}private static boolean tom_is_empty_PrioList_PrioDeclList( fiacre.types.PrioDeclList  l) {return  l.isEmptyPrioList() ;}   private static   fiacre.types.PrioDeclList  tom_append_list_PrioList( fiacre.types.PrioDeclList l1,  fiacre.types.PrioDeclList  l2) {     if( l1.isEmptyPrioList() ) {       return l2;     } else if( l2.isEmptyPrioList() ) {       return l1;     } else if(  l1.getTailPrioList() .isEmptyPrioList() ) {       return  fiacre.types.priodecllist.ConsPrioList.make( l1.getHeadPrioList() ,l2) ;     } else {       return  fiacre.types.priodecllist.ConsPrioList.make( l1.getHeadPrioList() ,tom_append_list_PrioList( l1.getTailPrioList() ,l2)) ;     }   }   private static   fiacre.types.PrioDeclList  tom_get_slice_PrioList( fiacre.types.PrioDeclList  begin,  fiacre.types.PrioDeclList  end, fiacre.types.PrioDeclList  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptyPrioList()  ||  (end==tom_empty_list_PrioList()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.priodecllist.ConsPrioList.make( begin.getHeadPrioList() ,( fiacre.types.PrioDeclList )tom_get_slice_PrioList( begin.getTailPrioList() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_lpdList( fiacre.types.LPDList  t) {return  ((t instanceof fiacre.types.lpdlist.ConslpdList) || (t instanceof fiacre.types.lpdlist.EmptylpdList)) ;}private static  fiacre.types.LPDList  tom_empty_list_lpdList() { return  fiacre.types.lpdlist.EmptylpdList.make() ;}private static  fiacre.types.LPDList  tom_cons_list_lpdList( fiacre.types.LocPortDecl  e,  fiacre.types.LPDList  l) { return  fiacre.types.lpdlist.ConslpdList.make(e,l) ;}private static  fiacre.types.LocPortDecl  tom_get_head_lpdList_LPDList( fiacre.types.LPDList  l) {return  l.getHeadlpdList() ;}private static  fiacre.types.LPDList  tom_get_tail_lpdList_LPDList( fiacre.types.LPDList  l) {return  l.getTaillpdList() ;}private static boolean tom_is_empty_lpdList_LPDList( fiacre.types.LPDList  l) {return  l.isEmptylpdList() ;}   private static   fiacre.types.LPDList  tom_append_list_lpdList( fiacre.types.LPDList l1,  fiacre.types.LPDList  l2) {     if( l1.isEmptylpdList() ) {       return l2;     } else if( l2.isEmptylpdList() ) {       return l1;     } else if(  l1.getTaillpdList() .isEmptylpdList() ) {       return  fiacre.types.lpdlist.ConslpdList.make( l1.getHeadlpdList() ,l2) ;     } else {       return  fiacre.types.lpdlist.ConslpdList.make( l1.getHeadlpdList() ,tom_append_list_lpdList( l1.getTaillpdList() ,l2)) ;     }   }   private static   fiacre.types.LPDList  tom_get_slice_lpdList( fiacre.types.LPDList  begin,  fiacre.types.LPDList  end, fiacre.types.LPDList  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptylpdList()  ||  (end==tom_empty_list_lpdList()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.lpdlist.ConslpdList.make( begin.getHeadlpdList() ,( fiacre.types.LPDList )tom_get_slice_lpdList( begin.getTaillpdList() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_ListPortDecl( fiacre.types.PortDecls  t) {return  ((t instanceof fiacre.types.portdecls.ConsListPortDecl) || (t instanceof fiacre.types.portdecls.EmptyListPortDecl)) ;}private static  fiacre.types.PortDecls  tom_empty_list_ListPortDecl() { return  fiacre.types.portdecls.EmptyListPortDecl.make() ;}private static  fiacre.types.PortDecls  tom_cons_list_ListPortDecl( fiacre.types.PortDecl  e,  fiacre.types.PortDecls  l) { return  fiacre.types.portdecls.ConsListPortDecl.make(e,l) ;}private static  fiacre.types.PortDecl  tom_get_head_ListPortDecl_PortDecls( fiacre.types.PortDecls  l) {return  l.getHeadListPortDecl() ;}private static  fiacre.types.PortDecls  tom_get_tail_ListPortDecl_PortDecls( fiacre.types.PortDecls  l) {return  l.getTailListPortDecl() ;}private static boolean tom_is_empty_ListPortDecl_PortDecls( fiacre.types.PortDecls  l) {return  l.isEmptyListPortDecl() ;}   private static   fiacre.types.PortDecls  tom_append_list_ListPortDecl( fiacre.types.PortDecls l1,  fiacre.types.PortDecls  l2) {     if( l1.isEmptyListPortDecl() ) {       return l2;     } else if( l2.isEmptyListPortDecl() ) {       return l1;     } else if(  l1.getTailListPortDecl() .isEmptyListPortDecl() ) {       return  fiacre.types.portdecls.ConsListPortDecl.make( l1.getHeadListPortDecl() ,l2) ;     } else {       return  fiacre.types.portdecls.ConsListPortDecl.make( l1.getHeadListPortDecl() ,tom_append_list_ListPortDecl( l1.getTailListPortDecl() ,l2)) ;     }   }   private static   fiacre.types.PortDecls  tom_get_slice_ListPortDecl( fiacre.types.PortDecls  begin,  fiacre.types.PortDecls  end, fiacre.types.PortDecls  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptyListPortDecl()  ||  (end==tom_empty_list_ListPortDecl()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.portdecls.ConsListPortDecl.make( begin.getHeadListPortDecl() ,( fiacre.types.PortDecls )tom_get_slice_ListPortDecl( begin.getTailListPortDecl() ,end,tail)) ;   }   private static boolean tom_is_fun_sym_GenInstList( fiacre.types.GenInsts  t) {return  ((t instanceof fiacre.types.geninsts.ConsGenInstList) || (t instanceof fiacre.types.geninsts.EmptyGenInstList)) ;}private static  fiacre.types.GenInsts  tom_empty_list_GenInstList() { return  fiacre.types.geninsts.EmptyGenInstList.make() ;}private static  fiacre.types.GenInsts  tom_cons_list_GenInstList( fiacre.types.GenInst  e,  fiacre.types.GenInsts  l) { return  fiacre.types.geninsts.ConsGenInstList.make(e,l) ;}private static  fiacre.types.GenInst  tom_get_head_GenInstList_GenInsts( fiacre.types.GenInsts  l) {return  l.getHeadGenInstList() ;}private static  fiacre.types.GenInsts  tom_get_tail_GenInstList_GenInsts( fiacre.types.GenInsts  l) {return  l.getTailGenInstList() ;}private static boolean tom_is_empty_GenInstList_GenInsts( fiacre.types.GenInsts  l) {return  l.isEmptyGenInstList() ;}   private static   fiacre.types.GenInsts  tom_append_list_GenInstList( fiacre.types.GenInsts l1,  fiacre.types.GenInsts  l2) {     if( l1.isEmptyGenInstList() ) {       return l2;     } else if( l2.isEmptyGenInstList() ) {       return l1;     } else if(  l1.getTailGenInstList() .isEmptyGenInstList() ) {       return  fiacre.types.geninsts.ConsGenInstList.make( l1.getHeadGenInstList() ,l2) ;     } else {       return  fiacre.types.geninsts.ConsGenInstList.make( l1.getHeadGenInstList() ,tom_append_list_GenInstList( l1.getTailGenInstList() ,l2)) ;     }   }   private static   fiacre.types.GenInsts  tom_get_slice_GenInstList( fiacre.types.GenInsts  begin,  fiacre.types.GenInsts  end, fiacre.types.GenInsts  tail) {     if( (begin==end) ) {       return tail;     } else if( (end==tail)  && ( end.isEmptyGenInstList()  ||  (end==tom_empty_list_GenInstList()) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  fiacre.types.geninsts.ConsGenInstList.make( begin.getHeadGenInstList() ,( fiacre.types.GenInsts )tom_get_slice_GenInstList( begin.getTailGenInstList() ,end,tail)) ;   }   private static boolean tom_equal_term_Strategy(Object t1, Object t2) {return  (t1.equals(t2)) ;}private static boolean tom_is_sort_Strategy(Object t) {return  (t instanceof tom.library.sl.Strategy) ;} private static boolean tom_equal_term_Position(Object t1, Object t2) {return  (t1.equals(t2)) ;}private static boolean tom_is_sort_Position(Object t) {return  (t instanceof tom.library.sl.Position) ;} private static  tom.library.sl.Strategy  tom_make_mu( tom.library.sl.Strategy  var,  tom.library.sl.Strategy  v) { return ( new tom.library.sl.Mu(var,v) );}private static  tom.library.sl.Strategy  tom_make_MuVar( String  name) { return ( new tom.library.sl.MuVar(name) );}private static  tom.library.sl.Strategy  tom_make_Identity() { return ( new tom.library.sl.Identity() );}private static  tom.library.sl.Strategy  tom_make_One( tom.library.sl.Strategy  v) { return ( new tom.library.sl.One(v) );}private static  tom.library.sl.Strategy  tom_make_All( tom.library.sl.Strategy  v) { return ( new tom.library.sl.All(v) );}private static  tom.library.sl.Strategy  tom_make_Fail() { return ( new tom.library.sl.Fail() );}private static boolean tom_is_fun_sym_Sequence( tom.library.sl.Strategy  t) {return ( t instanceof tom.library.sl.Sequence );}private static  tom.library.sl.Strategy  tom_empty_list_Sequence() { return  null ;}private static  tom.library.sl.Strategy  tom_cons_list_Sequence( tom.library.sl.Strategy  head,  tom.library.sl.Strategy  tail) { return  tom.library.sl.Sequence.make(head,tail) ;}private static  tom.library.sl.Strategy  tom_get_head_Sequence_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.Sequence.FIRST) );}private static  tom.library.sl.Strategy  tom_get_tail_Sequence_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.Sequence.THEN) );}private static boolean tom_is_empty_Sequence_Strategy( tom.library.sl.Strategy  t) {return ( t == null );}   private static   tom.library.sl.Strategy  tom_append_list_Sequence( tom.library.sl.Strategy  l1,  tom.library.sl.Strategy  l2) {     if(( l1 == null )) {       return l2;     } else if(( l2 == null )) {       return l1;     } else if(( l1 instanceof tom.library.sl.Sequence )) {       if(( ( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Sequence.THEN) ) == null )) {         return  tom.library.sl.Sequence.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Sequence.FIRST) ),l2) ;       } else {         return  tom.library.sl.Sequence.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Sequence.FIRST) ),tom_append_list_Sequence(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Sequence.THEN) ),l2)) ;       }     } else {       return  tom.library.sl.Sequence.make(l1,l2) ;     }   }   private static   tom.library.sl.Strategy  tom_get_slice_Sequence( tom.library.sl.Strategy  begin,  tom.library.sl.Strategy  end, tom.library.sl.Strategy  tail) {     if( (begin.equals(end)) ) {       return tail;     } else if( (end.equals(tail))  && (( end == null ) ||  (end.equals(tom_empty_list_Sequence())) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  tom.library.sl.Sequence.make(((( begin instanceof tom.library.sl.Sequence ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.Sequence.FIRST) ):begin),( tom.library.sl.Strategy )tom_get_slice_Sequence(((( begin instanceof tom.library.sl.Sequence ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.Sequence.THEN) ):tom_empty_list_Sequence()),end,tail)) ;   }   private static boolean tom_is_fun_sym_Choice( tom.library.sl.Strategy  t) {return ( t instanceof tom.library.sl.Choice );}private static  tom.library.sl.Strategy  tom_empty_list_Choice() { return  null ;}private static  tom.library.sl.Strategy  tom_cons_list_Choice( tom.library.sl.Strategy  head,  tom.library.sl.Strategy  tail) { return  tom.library.sl.Choice.make(head,tail) ;}private static  tom.library.sl.Strategy  tom_get_head_Choice_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.Choice.FIRST) );}private static  tom.library.sl.Strategy  tom_get_tail_Choice_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.Choice.THEN) );}private static boolean tom_is_empty_Choice_Strategy( tom.library.sl.Strategy  t) {return ( t ==null );}   private static   tom.library.sl.Strategy  tom_append_list_Choice( tom.library.sl.Strategy  l1,  tom.library.sl.Strategy  l2) {     if(( l1 ==null )) {       return l2;     } else if(( l2 ==null )) {       return l1;     } else if(( l1 instanceof tom.library.sl.Choice )) {       if(( ( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Choice.THEN) ) ==null )) {         return  tom.library.sl.Choice.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Choice.FIRST) ),l2) ;       } else {         return  tom.library.sl.Choice.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Choice.FIRST) ),tom_append_list_Choice(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.Choice.THEN) ),l2)) ;       }     } else {       return  tom.library.sl.Choice.make(l1,l2) ;     }   }   private static   tom.library.sl.Strategy  tom_get_slice_Choice( tom.library.sl.Strategy  begin,  tom.library.sl.Strategy  end, tom.library.sl.Strategy  tail) {     if( (begin.equals(end)) ) {       return tail;     } else if( (end.equals(tail))  && (( end ==null ) ||  (end.equals(tom_empty_list_Choice())) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  tom.library.sl.Choice.make(((( begin instanceof tom.library.sl.Choice ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.Choice.FIRST) ):begin),( tom.library.sl.Strategy )tom_get_slice_Choice(((( begin instanceof tom.library.sl.Choice ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.Choice.THEN) ):tom_empty_list_Choice()),end,tail)) ;   }   private static boolean tom_is_fun_sym_SequenceId( tom.library.sl.Strategy  t) {return ( t instanceof tom.library.sl.SequenceId );}private static  tom.library.sl.Strategy  tom_empty_list_SequenceId() { return  null ;}private static  tom.library.sl.Strategy  tom_cons_list_SequenceId( tom.library.sl.Strategy  head,  tom.library.sl.Strategy  tail) { return  tom.library.sl.SequenceId.make(head,tail) ;}private static  tom.library.sl.Strategy  tom_get_head_SequenceId_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.SequenceId.FIRST) );}private static  tom.library.sl.Strategy  tom_get_tail_SequenceId_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.SequenceId.THEN) );}private static boolean tom_is_empty_SequenceId_Strategy( tom.library.sl.Strategy  t) {return ( t == null );}   private static   tom.library.sl.Strategy  tom_append_list_SequenceId( tom.library.sl.Strategy  l1,  tom.library.sl.Strategy  l2) {     if(( l1 == null )) {       return l2;     } else if(( l2 == null )) {       return l1;     } else if(( l1 instanceof tom.library.sl.SequenceId )) {       if(( ( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.SequenceId.THEN) ) == null )) {         return  tom.library.sl.SequenceId.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.SequenceId.FIRST) ),l2) ;       } else {         return  tom.library.sl.SequenceId.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.SequenceId.FIRST) ),tom_append_list_SequenceId(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.SequenceId.THEN) ),l2)) ;       }     } else {       return  tom.library.sl.SequenceId.make(l1,l2) ;     }   }   private static   tom.library.sl.Strategy  tom_get_slice_SequenceId( tom.library.sl.Strategy  begin,  tom.library.sl.Strategy  end, tom.library.sl.Strategy  tail) {     if( (begin.equals(end)) ) {       return tail;     } else if( (end.equals(tail))  && (( end == null ) ||  (end.equals(tom_empty_list_SequenceId())) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  tom.library.sl.SequenceId.make(((( begin instanceof tom.library.sl.SequenceId ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.SequenceId.FIRST) ):begin),( tom.library.sl.Strategy )tom_get_slice_SequenceId(((( begin instanceof tom.library.sl.SequenceId ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.SequenceId.THEN) ):tom_empty_list_SequenceId()),end,tail)) ;   }   private static boolean tom_is_fun_sym_ChoiceId( tom.library.sl.Strategy  t) {return ( t instanceof tom.library.sl.ChoiceId );}private static  tom.library.sl.Strategy  tom_empty_list_ChoiceId() { return  null ;}private static  tom.library.sl.Strategy  tom_cons_list_ChoiceId( tom.library.sl.Strategy  head,  tom.library.sl.Strategy  tail) { return  tom.library.sl.ChoiceId.make(head,tail) ;}private static  tom.library.sl.Strategy  tom_get_head_ChoiceId_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.ChoiceId.FIRST) );}private static  tom.library.sl.Strategy  tom_get_tail_ChoiceId_Strategy( tom.library.sl.Strategy  t) {return ( (tom.library.sl.Strategy)t.getChildAt(tom.library.sl.ChoiceId.THEN) );}private static boolean tom_is_empty_ChoiceId_Strategy( tom.library.sl.Strategy  t) {return ( t ==null );}   private static   tom.library.sl.Strategy  tom_append_list_ChoiceId( tom.library.sl.Strategy  l1,  tom.library.sl.Strategy  l2) {     if(( l1 ==null )) {       return l2;     } else if(( l2 ==null )) {       return l1;     } else if(( l1 instanceof tom.library.sl.ChoiceId )) {       if(( ( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.ChoiceId.THEN) ) ==null )) {         return  tom.library.sl.ChoiceId.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.ChoiceId.FIRST) ),l2) ;       } else {         return  tom.library.sl.ChoiceId.make(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.ChoiceId.FIRST) ),tom_append_list_ChoiceId(( (tom.library.sl.Strategy)l1.getChildAt(tom.library.sl.ChoiceId.THEN) ),l2)) ;       }     } else {       return  tom.library.sl.ChoiceId.make(l1,l2) ;     }   }   private static   tom.library.sl.Strategy  tom_get_slice_ChoiceId( tom.library.sl.Strategy  begin,  tom.library.sl.Strategy  end, tom.library.sl.Strategy  tail) {     if( (begin.equals(end)) ) {       return tail;     } else if( (end.equals(tail))  && (( end ==null ) ||  (end.equals(tom_empty_list_ChoiceId())) )) {       /* code to avoid a call to make, and thus to avoid looping during list-matching */       return begin;     }     return  tom.library.sl.ChoiceId.make(((( begin instanceof tom.library.sl.ChoiceId ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.ChoiceId.FIRST) ):begin),( tom.library.sl.Strategy )tom_get_slice_ChoiceId(((( begin instanceof tom.library.sl.ChoiceId ))?( (tom.library.sl.Strategy)begin.getChildAt(tom.library.sl.ChoiceId.THEN) ):tom_empty_list_ChoiceId()),end,tail)) ;   }   private static  tom.library.sl.Strategy  tom_make_OneId( tom.library.sl.Strategy  v) { return ( new tom.library.sl.OneId(v) );}   private static  tom.library.sl.Strategy  tom_make_AllSeq( tom.library.sl.Strategy  s) { return ( new tom.library.sl.AllSeq(s) );}private static  tom.library.sl.Strategy  tom_make_AUCtl( tom.library.sl.Strategy  s1,  tom.library.sl.Strategy  s2) { return ( tom_make_mu(tom_make_MuVar("x"),tom_cons_list_Choice(s2,tom_cons_list_Choice(tom_cons_list_Sequence(tom_cons_list_Sequence(s1,tom_cons_list_Sequence(tom_make_All(tom_make_MuVar("x")),tom_empty_list_Sequence())),tom_cons_list_Sequence(tom_make_One(tom_make_Identity()),tom_empty_list_Sequence())),tom_empty_list_Choice()))) );}private static  tom.library.sl.Strategy  tom_make_EUCtl( tom.library.sl.Strategy  s1,  tom.library.sl.Strategy  s2) { return ( tom_make_mu(tom_make_MuVar("x"),tom_cons_list_Choice(s2,tom_cons_list_Choice(tom_cons_list_Sequence(s1,tom_cons_list_Sequence(tom_make_One(tom_make_MuVar("x")),tom_empty_list_Sequence())),tom_empty_list_Choice()))));} private static  tom.library.sl.Strategy  tom_make_Try( tom.library.sl.Strategy  s) { return ( tom_cons_list_Choice(s,tom_cons_list_Choice(tom_make_Identity(),tom_empty_list_Choice())) );}private static  tom.library.sl.Strategy  tom_make_Repeat( tom.library.sl.Strategy  s) { return ( tom_make_mu(tom_make_MuVar("_x"),tom_cons_list_Choice(tom_cons_list_Sequence(s,tom_cons_list_Sequence(tom_make_MuVar("_x"),tom_empty_list_Sequence())),tom_cons_list_Choice(tom_make_Identity(),tom_empty_list_Choice()))) );}private static  tom.library.sl.Strategy  tom_make_TopDown( tom.library.sl.Strategy  v) { return ( tom_make_mu(tom_make_MuVar("_x"),tom_cons_list_Sequence(v,tom_cons_list_Sequence(tom_make_All(tom_make_MuVar("_x")),tom_empty_list_Sequence()))) );}private static  tom.library.sl.Strategy  tom_make_OnceTopDown( tom.library.sl.Strategy  v) { return ( tom_make_mu(tom_make_MuVar("_x"),tom_cons_list_Choice(v,tom_cons_list_Choice(tom_make_One(tom_make_MuVar("_x")),tom_empty_list_Choice()))) );}private static  tom.library.sl.Strategy  tom_make_RepeatId( tom.library.sl.Strategy  v) { return ( tom_make_mu(tom_make_MuVar("_x"),tom_cons_list_SequenceId(v,tom_cons_list_SequenceId(tom_make_MuVar("_x"),tom_empty_list_SequenceId()))) );}private static  tom.library.sl.Strategy  tom_make_OnceTopDownId( tom.library.sl.Strategy  v) { return ( tom_make_mu(tom_make_MuVar("_x"),tom_cons_list_ChoiceId(v,tom_cons_list_ChoiceId(tom_make_OneId(tom_make_MuVar("_x")),tom_empty_list_ChoiceId()))) );}   private static  tom.library.sl.Strategy  tom_make_Is_ObsItem() { return  new fiacre.strategy.observable.Is_ObsItem();}private static  tom.library.sl.Strategy  tom_make_Is_ObsUnary() { return  new fiacre.strategy.observable.Is_ObsUnary();}private static  tom.library.sl.Strategy  tom_make_Is_ObsBinary() { return  new fiacre.strategy.observable.Is_ObsBinary();}private static  tom.library.sl.Strategy  tom_make_Is_ObsPar() { return  new fiacre.strategy.observable.Is_ObsPar();}private static  tom.library.sl.Strategy  tom_make_Is_OptExp() { return  new fiacre.strategy.optional_exp.Is_OptExp();}private static  tom.library.sl.Strategy  tom_make_Is_NoneExp() { return  new fiacre.strategy.optional_exp.Is_NoneExp();}private static  tom.library.sl.Strategy  tom_make_Is_profile() { return  new fiacre.strategy.profile.Is_profile();}private static  tom.library.sl.Strategy  tom_make__EmptyType_list() { return  new fiacre.strategy.typelist._EmptyType_list() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyType_list() { return  new fiacre.strategy.typelist.Is_EmptyType_list();}private static  tom.library.sl.Strategy  tom_make__ConsType_list( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.typelist._ConsType_list(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsType_list() { return  new fiacre.strategy.typelist.Is_ConsType_list();}private static  tom.library.sl.Strategy  tom_make_Is_Inst() { return  new fiacre.strategy.instance.Is_Inst();}private static  tom.library.sl.Strategy  tom_make__EmptyPStmList() { return  new fiacre.strategy.pstatementlist._EmptyPStmList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyPStmList() { return  new fiacre.strategy.pstatementlist.Is_EmptyPStmList();}private static  tom.library.sl.Strategy  tom_make__ConsPStmList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.pstatementlist._ConsPStmList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsPStmList() { return  new fiacre.strategy.pstatementlist.Is_ConsPStmList();}private static  tom.library.sl.Strategy  tom_make__EmptyVAList() { return  new fiacre.strategy.varattrlist._EmptyVAList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyVAList() { return  new fiacre.strategy.varattrlist.Is_EmptyVAList();}private static  tom.library.sl.Strategy  tom_make__ConsVAList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.varattrlist._ConsVAList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsVAList() { return  new fiacre.strategy.varattrlist.Is_ConsVAList();}private static  tom.library.sl.Strategy  tom_make__EmptyAffList() { return  new fiacre.strategy.affectationlist._EmptyAffList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyAffList() { return  new fiacre.strategy.affectationlist.Is_EmptyAffList();}private static  tom.library.sl.Strategy  tom_make__ConsAffList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.affectationlist._ConsAffList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsAffList() { return  new fiacre.strategy.affectationlist.Is_ConsAffList();}private static  tom.library.sl.Strategy  tom_make__EmptylistExp() { return  new fiacre.strategy.explist._EmptylistExp() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptylistExp() { return  new fiacre.strategy.explist.Is_EmptylistExp();}private static  tom.library.sl.Strategy  tom_make__ConslistExp( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.explist._ConslistExp(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConslistExp() { return  new fiacre.strategy.explist.Is_ConslistExp();}private static  tom.library.sl.Strategy  tom_make__EmptyPCList() { return  new fiacre.strategy.portcomplist._EmptyPCList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyPCList() { return  new fiacre.strategy.portcomplist.Is_EmptyPCList();}private static  tom.library.sl.Strategy  tom_make__ConsPCList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.portcomplist._ConsPCList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsPCList() { return  new fiacre.strategy.portcomplist.Is_ConsPCList();}private static  tom.library.sl.Strategy  tom_make_Is_READ() { return  new fiacre.strategy.varattr.Is_READ();}private static  tom.library.sl.Strategy  tom_make_Is_WRITE() { return  new fiacre.strategy.varattr.Is_WRITE();}private static  tom.library.sl.Strategy  tom_make_Is_Cident() { return  new fiacre.strategy.cindex.Is_Cident();}private static  tom.library.sl.Strategy  tom_make_Is_Cnum() { return  new fiacre.strategy.cindex.Is_Cnum();}private static  tom.library.sl.Strategy  tom_make_Is_PropLTL() { return  new fiacre.strategy.property.Is_PropLTL();}private static  tom.library.sl.Strategy  tom_make_Is_PropO() { return  new fiacre.strategy.property.Is_PropO();}private static  tom.library.sl.Strategy  tom_make_Is_PropOx() { return  new fiacre.strategy.property.Is_PropOx();}private static  tom.library.sl.Strategy  tom_make_Is_PropOxOx() { return  new fiacre.strategy.property.Is_PropOxOx();}private static  tom.library.sl.Strategy  tom_make_Is_PropxOx() { return  new fiacre.strategy.property.Is_PropxOx();}private static  tom.library.sl.Strategy  tom_make_Is_PropOxOxOx() { return  new fiacre.strategy.property.Is_PropOxOxOx();}private static  tom.library.sl.Strategy  tom_make_Is_PropOxOxOd() { return  new fiacre.strategy.property.Is_PropOxOxOd();}private static  tom.library.sl.Strategy  tom_make_Is_PropxOxOxOx() { return  new fiacre.strategy.property.Is_PropxOxOxOx();}private static  tom.library.sl.Strategy  tom_make_Is_PropxOxOx() { return  new fiacre.strategy.property.Is_PropxOxOx();}private static  tom.library.sl.Strategy  tom_make_Is_PropOxOxOI() { return  new fiacre.strategy.property.Is_PropOxOxOI();}private static  tom.library.sl.Strategy  tom_make_Is_PropOxOd() { return  new fiacre.strategy.property.Is_PropOxOd();}private static  tom.library.sl.Strategy  tom_make_Is_PropxOxOI() { return  new fiacre.strategy.property.Is_PropxOxOI();}private static  tom.library.sl.Strategy  tom_make_Is_PropxOxOxOI() { return  new fiacre.strategy.property.Is_PropxOxOxOI();}private static  tom.library.sl.Strategy  tom_make_Is_PropBin() { return  new fiacre.strategy.property.Is_PropBin();}private static  tom.library.sl.Strategy  tom_make_Is_PropNot() { return  new fiacre.strategy.property.Is_PropNot();}private static  tom.library.sl.Strategy  tom_make_Is_PropPar() { return  new fiacre.strategy.property.Is_PropPar();}private static  tom.library.sl.Strategy  tom_make_Is_PropAll() { return  new fiacre.strategy.property.Is_PropAll();}private static  tom.library.sl.Strategy  tom_make_Is_PropEx() { return  new fiacre.strategy.property.Is_PropEx();}private static  tom.library.sl.Strategy  tom_make__EmptyCondStList() { return  new fiacre.strategy.conditionalstatementlist._EmptyCondStList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyCondStList() { return  new fiacre.strategy.conditionalstatementlist.Is_EmptyCondStList();}private static  tom.library.sl.Strategy  tom_make__ConsCondStList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.conditionalstatementlist._ConsCondStList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsCondStList() { return  new fiacre.strategy.conditionalstatementlist.Is_ConsCondStList();}private static  tom.library.sl.Strategy  tom_make_Is_NamedChannel() { return  new fiacre.strategy.channel.Is_NamedChannel();}private static  tom.library.sl.Strategy  tom_make_Is_ProfileChannel() { return  new fiacre.strategy.channel.Is_ProfileChannel();}private static  tom.library.sl.Strategy  tom_make_Is_PortComp() { return  new fiacre.strategy.portcomposition.Is_PortComp();}private static  tom.library.sl.Strategy  tom_make__EmptystringList() { return  new fiacre.strategy.stringlist._EmptystringList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptystringList() { return  new fiacre.strategy.stringlist.Is_EmptystringList();}private static  tom.library.sl.Strategy  tom_make__ConsstringList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.stringlist._ConsstringList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsstringList() { return  new fiacre.strategy.stringlist.Is_ConsstringList();}private static  tom.library.sl.Strategy  tom_make_Is_VarDec() { return  new fiacre.strategy.vardecl.Is_VarDec();}private static  tom.library.sl.Strategy  tom_make_Is_Open() { return  new fiacre.strategy.bound.Is_Open();}private static  tom.library.sl.Strategy  tom_make_Is_Closed() { return  new fiacre.strategy.bound.Is_Closed();}private static  tom.library.sl.Strategy  tom_make_Is_Infinite() { return  new fiacre.strategy.bound.Is_Infinite();}private static  tom.library.sl.Strategy  tom_make_Is_IN() { return  new fiacre.strategy.portattr.Is_IN();}private static  tom.library.sl.Strategy  tom_make_Is_OUT() { return  new fiacre.strategy.portattr.Is_OUT();}private static  tom.library.sl.Strategy  tom_make_Is_NONE() { return  new fiacre.strategy.portattr.Is_NONE();}private static  tom.library.sl.Strategy  tom_make__EmptyDeclarationList() { return  new fiacre.strategy.declarations._EmptyDeclarationList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyDeclarationList() { return  new fiacre.strategy.declarations.Is_EmptyDeclarationList();}private static  tom.library.sl.Strategy  tom_make__ConsDeclarationList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.declarations._ConsDeclarationList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsDeclarationList() { return  new fiacre.strategy.declarations.Is_ConsDeclarationList();}private static  tom.library.sl.Strategy  tom_make_Is_PortDec() { return  new fiacre.strategy.portdecl.Is_PortDec();}private static  tom.library.sl.Strategy  tom_make_Is_Decl() { return  new fiacre.strategy.optional_decl.Is_Decl();}private static  tom.library.sl.Strategy  tom_make_Is_NoneDecl() { return  new fiacre.strategy.optional_decl.Is_NoneDecl();}private static  tom.library.sl.Strategy  tom_make_Is_OPathFrom() { return  new fiacre.strategy.opath.Is_OPathFrom();}private static  tom.library.sl.Strategy  tom_make__EmptyStmList() { return  new fiacre.strategy.statementlist._EmptyStmList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyStmList() { return  new fiacre.strategy.statementlist.Is_EmptyStmList();}private static  tom.library.sl.Strategy  tom_make__ConsStmList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.statementlist._ConsStmList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsStmList() { return  new fiacre.strategy.statementlist.Is_ConsStmList();}private static  tom.library.sl.Strategy  tom_make_Is_IState() { return  new fiacre.strategy.item.Is_IState();}private static  tom.library.sl.Strategy  tom_make_Is_ITag() { return  new fiacre.strategy.item.Is_ITag();}private static  tom.library.sl.Strategy  tom_make_Is_IEvent() { return  new fiacre.strategy.item.Is_IEvent();}private static  tom.library.sl.Strategy  tom_make_Is_IValue() { return  new fiacre.strategy.item.Is_IValue();}private static  tom.library.sl.Strategy  tom_make__EmptyListVarDecl() { return  new fiacre.strategy.vardecls._EmptyListVarDecl() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyListVarDecl() { return  new fiacre.strategy.vardecls.Is_EmptyListVarDecl();}private static  tom.library.sl.Strategy  tom_make__ConsListVarDecl( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.vardecls._ConsListVarDecl(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsListVarDecl() { return  new fiacre.strategy.vardecls.Is_ConsListVarDecl();}private static  tom.library.sl.Strategy  tom_make__EmptyfieldList() { return  new fiacre.strategy.fieldsdecllist._EmptyfieldList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyfieldList() { return  new fiacre.strategy.fieldsdecllist.Is_EmptyfieldList();}private static  tom.library.sl.Strategy  tom_make__ConsfieldList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.fieldsdecllist._ConsfieldList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsfieldList() { return  new fiacre.strategy.fieldsdecllist.Is_ConsfieldList();}private static  tom.library.sl.Strategy  tom_make__EmptyPrioList() { return  new fiacre.strategy.priodecllist._EmptyPrioList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyPrioList() { return  new fiacre.strategy.priodecllist.Is_EmptyPrioList();}private static  tom.library.sl.Strategy  tom_make__ConsPrioList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.priodecllist._ConsPrioList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsPrioList() { return  new fiacre.strategy.priodecllist.Is_ConsPrioList();}private static  tom.library.sl.Strategy  tom_make_Is_OpenKind() { return  new fiacre.strategy.kind.Is_OpenKind();}private static  tom.library.sl.Strategy  tom_make_Is_VarKind() { return  new fiacre.strategy.kind.Is_VarKind();}private static  tom.library.sl.Strategy  tom_make_Is_ConstantKind() { return  new fiacre.strategy.kind.Is_ConstantKind();}private static  tom.library.sl.Strategy  tom_make_Is_ConstrKind() { return  new fiacre.strategy.kind.Is_ConstrKind();}private static  tom.library.sl.Strategy  tom_make_Is_LocPortDec() { return  new fiacre.strategy.locportdecl.Is_LocPortDec();}private static  tom.library.sl.Strategy  tom_make_Is_parCompo() { return  new fiacre.strategy.parcomposition.Is_parCompo();}private static  tom.library.sl.Strategy  tom_make_Is_parCompoB() { return  new fiacre.strategy.parcomposition.Is_parCompoB();}private static  tom.library.sl.Strategy  tom_make_Is_BoolType() { return  new fiacre.strategy.type.Is_BoolType();}private static  tom.library.sl.Strategy  tom_make_Is_NatType() { return  new fiacre.strategy.type.Is_NatType();}private static  tom.library.sl.Strategy  tom_make_Is_IntType() { return  new fiacre.strategy.type.Is_IntType();}private static  tom.library.sl.Strategy  tom_make_Is_NamedType() { return  new fiacre.strategy.type.Is_NamedType();}private static  tom.library.sl.Strategy  tom_make_Is_IntervalType() { return  new fiacre.strategy.type.Is_IntervalType();}private static  tom.library.sl.Strategy  tom_make_Is_UnionType() { return  new fiacre.strategy.type.Is_UnionType();}private static  tom.library.sl.Strategy  tom_make_Is_RecordType() { return  new fiacre.strategy.type.Is_RecordType();}private static  tom.library.sl.Strategy  tom_make_Is_ArrayType() { return  new fiacre.strategy.type.Is_ArrayType();}private static  tom.library.sl.Strategy  tom_make_Is_QueueType() { return  new fiacre.strategy.type.Is_QueueType();}private static  tom.library.sl.Strategy  tom_make_Is_AnyArray() { return  new fiacre.strategy.type.Is_AnyArray();}private static  tom.library.sl.Strategy  tom_make_Is_AnyQueue() { return  new fiacre.strategy.type.Is_AnyQueue();}private static  tom.library.sl.Strategy  tom_make_Is_BotType() { return  new fiacre.strategy.type.Is_BotType();}private static  tom.library.sl.Strategy  tom_make_Is_TopType() { return  new fiacre.strategy.type.Is_TopType();}private static  tom.library.sl.Strategy  tom_make_Is_PortType() { return  new fiacre.strategy.type.Is_PortType();}private static  tom.library.sl.Strategy  tom_make_Is_ENQUEUE() { return  new fiacre.strategy.binop.Is_ENQUEUE();}private static  tom.library.sl.Strategy  tom_make_Is_APPEND() { return  new fiacre.strategy.binop.Is_APPEND();}private static  tom.library.sl.Strategy  tom_make_Is_field() { return  new fiacre.strategy.fieldsdecl.Is_field();}private static  tom.library.sl.Strategy  tom_make_Is_LtlObs() { return  new fiacre.strategy.ltl.Is_LtlObs();}private static  tom.library.sl.Strategy  tom_make_Is_LtlAtom() { return  new fiacre.strategy.ltl.Is_LtlAtom();}private static  tom.library.sl.Strategy  tom_make_Is_LtlAll() { return  new fiacre.strategy.ltl.Is_LtlAll();}private static  tom.library.sl.Strategy  tom_make_Is_LtlEx() { return  new fiacre.strategy.ltl.Is_LtlEx();}private static  tom.library.sl.Strategy  tom_make_Is_LtlUnary() { return  new fiacre.strategy.ltl.Is_LtlUnary();}private static  tom.library.sl.Strategy  tom_make_Is_LtlBinary() { return  new fiacre.strategy.ltl.Is_LtlBinary();}private static  tom.library.sl.Strategy  tom_make_Is_LtlPar() { return  new fiacre.strategy.ltl.Is_LtlPar();}private static  tom.library.sl.Strategy  tom_make_Is_AllPorts() { return  new fiacre.strategy.portset.Is_AllPorts();}private static  tom.library.sl.Strategy  tom_make_Is_SomePorts() { return  new fiacre.strategy.portset.Is_SomePorts();}private static  tom.library.sl.Strategy  tom_make_Is_TypeInst() { return  new fiacre.strategy.geninst.Is_TypeInst();}private static  tom.library.sl.Strategy  tom_make_Is_ConstInst() { return  new fiacre.strategy.geninst.Is_ConstInst();}private static  tom.library.sl.Strategy  tom_make_Is_Constr0Inst() { return  new fiacre.strategy.geninst.Is_Constr0Inst();}private static  tom.library.sl.Strategy  tom_make_Is_Constr1Inst() { return  new fiacre.strategy.geninst.Is_Constr1Inst();}private static  tom.library.sl.Strategy  tom_make_Is_TypeDecl() { return  new fiacre.strategy.declaration.Is_TypeDecl();}private static  tom.library.sl.Strategy  tom_make_Is_ChannelDecl() { return  new fiacre.strategy.declaration.Is_ChannelDecl();}private static  tom.library.sl.Strategy  tom_make_Is_ConstantDecl() { return  new fiacre.strategy.declaration.Is_ConstantDecl();}private static  tom.library.sl.Strategy  tom_make_Is_ProcessDecl() { return  new fiacre.strategy.declaration.Is_ProcessDecl();}private static  tom.library.sl.Strategy  tom_make_Is_ExtendedProcessDecl() { return  new fiacre.strategy.declaration.Is_ExtendedProcessDecl();}private static  tom.library.sl.Strategy  tom_make_Is_ComponentDecl() { return  new fiacre.strategy.declaration.Is_ComponentDecl();}private static  tom.library.sl.Strategy  tom_make_Is_Main() { return  new fiacre.strategy.declaration.Is_Main();}private static  tom.library.sl.Strategy  tom_make_Is_PropertyDecl() { return  new fiacre.strategy.declaration.Is_PropertyDecl();}private static  tom.library.sl.Strategy  tom_make_Is_Assert() { return  new fiacre.strategy.declaration.Is_Assert();}private static  tom.library.sl.Strategy  tom_make_Is_ValArg() { return  new fiacre.strategy.arg.Is_ValArg();}private static  tom.library.sl.Strategy  tom_make_Is_RefArg() { return  new fiacre.strategy.arg.Is_RefArg();}private static  tom.library.sl.Strategy  tom_make_Is_ArrayRefArg() { return  new fiacre.strategy.arg.Is_ArrayRefArg();}private static  tom.library.sl.Strategy  tom_make_Is_Initial() { return  new fiacre.strategy.init.Is_Initial();}private static  tom.library.sl.Strategy  tom_make_Is_NoneInit() { return  new fiacre.strategy.init.Is_NoneInit();}private static  tom.library.sl.Strategy  tom_make_Is_ParComp() { return  new fiacre.strategy.composition.Is_ParComp();}private static  tom.library.sl.Strategy  tom_make_Is_InstanceComp() { return  new fiacre.strategy.composition.Is_InstanceComp();}private static  tom.library.sl.Strategy  tom_make__EmptylpdList() { return  new fiacre.strategy.lpdlist._EmptylpdList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptylpdList() { return  new fiacre.strategy.lpdlist.Is_EmptylpdList();}private static  tom.library.sl.Strategy  tom_make__ConslpdList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.lpdlist._ConslpdList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConslpdList() { return  new fiacre.strategy.lpdlist.Is_ConslpdList();}private static  tom.library.sl.Strategy  tom_make_Is_Paramdec() { return  new fiacre.strategy.paramdecl.Is_Paramdec();}private static  tom.library.sl.Strategy  tom_make__EmptyArList() { return  new fiacre.strategy.arglist._EmptyArList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyArList() { return  new fiacre.strategy.arglist.Is_EmptyArList();}private static  tom.library.sl.Strategy  tom_make__ConsArList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.arglist._ConsArList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsArList() { return  new fiacre.strategy.arglist.Is_ConsArList();}private static  tom.library.sl.Strategy  tom_make_Is_ParenExp() { return  new fiacre.strategy.exp.Is_ParenExp();}private static  tom.library.sl.Strategy  tom_make_Is_CondExp() { return  new fiacre.strategy.exp.Is_CondExp();}private static  tom.library.sl.Strategy  tom_make_Is_Unop() { return  new fiacre.strategy.exp.Is_Unop();}private static  tom.library.sl.Strategy  tom_make_Is_Binop() { return  new fiacre.strategy.exp.Is_Binop();}private static  tom.library.sl.Strategy  tom_make_Is_Infix() { return  new fiacre.strategy.exp.Is_Infix();}private static  tom.library.sl.Strategy  tom_make_Is_RecordExp() { return  new fiacre.strategy.exp.Is_RecordExp();}private static  tom.library.sl.Strategy  tom_make_Is_QueueExp() { return  new fiacre.strategy.exp.Is_QueueExp();}private static  tom.library.sl.Strategy  tom_make_Is_ArrayExp() { return  new fiacre.strategy.exp.Is_ArrayExp();}private static  tom.library.sl.Strategy  tom_make_Is_RefExp() { return  new fiacre.strategy.exp.Is_RefExp();}private static  tom.library.sl.Strategy  tom_make_Is_ConstrExp() { return  new fiacre.strategy.exp.Is_ConstrExp();}private static  tom.library.sl.Strategy  tom_make_Is_IntExp() { return  new fiacre.strategy.exp.Is_IntExp();}private static  tom.library.sl.Strategy  tom_make_Is_BoolExp() { return  new fiacre.strategy.exp.Is_BoolExp();}private static  tom.library.sl.Strategy  tom_make_Is_IdentExp() { return  new fiacre.strategy.exp.Is_IdentExp();}private static  tom.library.sl.Strategy  tom_make_Is_AnyExp() { return  new fiacre.strategy.exp.Is_AnyExp();}private static  tom.library.sl.Strategy  tom_make_Is_ArrayAccessExp() { return  new fiacre.strategy.exp.Is_ArrayAccessExp();}private static  tom.library.sl.Strategy  tom_make_Is_RecordAccessExp() { return  new fiacre.strategy.exp.Is_RecordAccessExp();}private static  tom.library.sl.Strategy  tom_make_Is_InitListExp() { return  new fiacre.strategy.exp.Is_InitListExp();}private static  tom.library.sl.Strategy  tom_make_Is_MultExp() { return  new fiacre.strategy.exp.Is_MultExp();}private static  tom.library.sl.Strategy  tom_make_Is_ChanProjExp() { return  new fiacre.strategy.exp.Is_ChanProjExp();}private static  tom.library.sl.Strategy  tom_make_Is_AllExp() { return  new fiacre.strategy.exp.Is_AllExp();}private static  tom.library.sl.Strategy  tom_make_Is_ExistsExp() { return  new fiacre.strategy.exp.Is_ExistsExp();}private static  tom.library.sl.Strategy  tom_make_Is_Prog() { return  new fiacre.strategy.program_fiacre.Is_Prog();}private static  tom.library.sl.Strategy  tom_make__EmptyListParamDecl() { return  new fiacre.strategy.paramdecls._EmptyListParamDecl() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyListParamDecl() { return  new fiacre.strategy.paramdecls.Is_EmptyListParamDecl();}private static  tom.library.sl.Strategy  tom_make__ConsListParamDecl( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.paramdecls._ConsListParamDecl(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsListParamDecl() { return  new fiacre.strategy.paramdecls.Is_ConsListParamDecl();}private static  tom.library.sl.Strategy  tom_make__EmptyTransList() { return  new fiacre.strategy.transitions._EmptyTransList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyTransList() { return  new fiacre.strategy.transitions.Is_EmptyTransList();}private static  tom.library.sl.Strategy  tom_make__ConsTransList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.transitions._ConsTransList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsTransList() { return  new fiacre.strategy.transitions.Is_ConsTransList();}private static  tom.library.sl.Strategy  tom_make_Is_Statmt() { return  new fiacre.strategy.optional_statement.Is_Statmt();}private static  tom.library.sl.Strategy  tom_make_Is_NoneSt() { return  new fiacre.strategy.optional_statement.Is_NoneSt();}private static  tom.library.sl.Strategy  tom_make_Is_StNull() { return  new fiacre.strategy.statement.Is_StNull();}private static  tom.library.sl.Strategy  tom_make_Is_StTag() { return  new fiacre.strategy.statement.Is_StTag();}private static  tom.library.sl.Strategy  tom_make_Is_StCond() { return  new fiacre.strategy.statement.Is_StCond();}private static  tom.library.sl.Strategy  tom_make_Is_StSelect() { return  new fiacre.strategy.statement.Is_StSelect();}private static  tom.library.sl.Strategy  tom_make_Is_StSelectIndexe() { return  new fiacre.strategy.statement.Is_StSelectIndexe();}private static  tom.library.sl.Strategy  tom_make_Is_StSequence() { return  new fiacre.strategy.statement.Is_StSequence();}private static  tom.library.sl.Strategy  tom_make_Is_StTo() { return  new fiacre.strategy.statement.Is_StTo();}private static  tom.library.sl.Strategy  tom_make_Is_StWhile() { return  new fiacre.strategy.statement.Is_StWhile();}private static  tom.library.sl.Strategy  tom_make_Is_StAssign() { return  new fiacre.strategy.statement.Is_StAssign();}private static  tom.library.sl.Strategy  tom_make_Is_StAny() { return  new fiacre.strategy.statement.Is_StAny();}private static  tom.library.sl.Strategy  tom_make_Is_StSignal() { return  new fiacre.strategy.statement.Is_StSignal();}private static  tom.library.sl.Strategy  tom_make_Is_StInput() { return  new fiacre.strategy.statement.Is_StInput();}private static  tom.library.sl.Strategy  tom_make_Is_StOutput() { return  new fiacre.strategy.statement.Is_StOutput();}private static  tom.library.sl.Strategy  tom_make_Is_StCase() { return  new fiacre.strategy.statement.Is_StCase();}private static  tom.library.sl.Strategy  tom_make_Is_StForEach() { return  new fiacre.strategy.statement.Is_StForEach();}private static  tom.library.sl.Strategy  tom_make_Is_StLoop() { return  new fiacre.strategy.statement.Is_StLoop();}private static  tom.library.sl.Strategy  tom_make_Is_StOn() { return  new fiacre.strategy.statement.Is_StOn();}private static  tom.library.sl.Strategy  tom_make_Is_StWait() { return  new fiacre.strategy.statement.Is_StWait();}private static  tom.library.sl.Strategy  tom_make_Is_duration() { return  new fiacre.strategy.duration.Is_duration();}private static  tom.library.sl.Strategy  tom_make__EmptyCaseEL() { return  new fiacre.strategy.caseelementlist._EmptyCaseEL() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyCaseEL() { return  new fiacre.strategy.caseelementlist.Is_EmptyCaseEL();}private static  tom.library.sl.Strategy  tom_make__ConsCaseEL( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.caseelementlist._ConsCaseEL(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsCaseEL() { return  new fiacre.strategy.caseelementlist.Is_ConsCaseEL();}private static  tom.library.sl.Strategy  tom_make_Is_MINUS() { return  new fiacre.strategy.unop.Is_MINUS();}private static  tom.library.sl.Strategy  tom_make_Is_PLUS() { return  new fiacre.strategy.unop.Is_PLUS();}private static  tom.library.sl.Strategy  tom_make_Is_NOT() { return  new fiacre.strategy.unop.Is_NOT();}private static  tom.library.sl.Strategy  tom_make_Is_COERCE() { return  new fiacre.strategy.unop.Is_COERCE();}private static  tom.library.sl.Strategy  tom_make_Is_FULL() { return  new fiacre.strategy.unop.Is_FULL();}private static  tom.library.sl.Strategy  tom_make_Is_EMPTY() { return  new fiacre.strategy.unop.Is_EMPTY();}private static  tom.library.sl.Strategy  tom_make_Is_DEQUEUE() { return  new fiacre.strategy.unop.Is_DEQUEUE();}private static  tom.library.sl.Strategy  tom_make_Is_FIRST() { return  new fiacre.strategy.unop.Is_FIRST();}private static  tom.library.sl.Strategy  tom_make_Is_LENGTH() { return  new fiacre.strategy.unop.Is_LENGTH();}private static  tom.library.sl.Strategy  tom_make__EmptyListPortDecl() { return  new fiacre.strategy.portdecls._EmptyListPortDecl() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyListPortDecl() { return  new fiacre.strategy.portdecls.Is_EmptyListPortDecl();}private static  tom.library.sl.Strategy  tom_make__ConsListPortDecl( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.portdecls._ConsListPortDecl(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsListPortDecl() { return  new fiacre.strategy.portdecls.Is_ConsListPortDecl();}private static  tom.library.sl.Strategy  tom_make__EmptyGenInstList() { return  new fiacre.strategy.geninsts._EmptyGenInstList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyGenInstList() { return  new fiacre.strategy.geninsts.Is_EmptyGenInstList();}private static  tom.library.sl.Strategy  tom_make__ConsGenInstList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.geninsts._ConsGenInstList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsGenInstList() { return  new fiacre.strategy.geninsts.Is_ConsGenInstList();}private static  tom.library.sl.Strategy  tom_make__EmptyPAList() { return  new fiacre.strategy.portattrlist._EmptyPAList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyPAList() { return  new fiacre.strategy.portattrlist.Is_EmptyPAList();}private static  tom.library.sl.Strategy  tom_make__ConsPAList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.portattrlist._ConsPAList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsPAList() { return  new fiacre.strategy.portattrlist.Is_ConsPAList();}private static  tom.library.sl.Strategy  tom_make_Is_Affect() { return  new fiacre.strategy.affectation.Is_Affect();}private static  tom.library.sl.Strategy  tom_make__EmptyPriorDec() { return  new fiacre.strategy.priordecl._EmptyPriorDec() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyPriorDec() { return  new fiacre.strategy.priordecl.Is_EmptyPriorDec();}private static  tom.library.sl.Strategy  tom_make__ConsPriorDec( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.priordecl._ConsPriorDec(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsPriorDec() { return  new fiacre.strategy.priordecl.Is_ConsPriorDec();}private static  tom.library.sl.Strategy  tom_make_Is_ConditionalStmt() { return  new fiacre.strategy.conditionalstatement.Is_ConditionalStmt();}private static  tom.library.sl.Strategy  tom_make__EmptyIndexList() { return  new fiacre.strategy.rpath._EmptyIndexList() ;}private static  tom.library.sl.Strategy  tom_make_Is_EmptyIndexList() { return  new fiacre.strategy.rpath.Is_EmptyIndexList();}private static  tom.library.sl.Strategy  tom_make__ConsIndexList( tom.library.sl.Strategy  arg0,  tom.library.sl.Strategy  arg1) { return  new fiacre.strategy.rpath._ConsIndexList(arg0, arg1) ;}private static  tom.library.sl.Strategy  tom_make_Is_ConsIndexList() { return  new fiacre.strategy.rpath.Is_ConsIndexList();}private static  tom.library.sl.Strategy  tom_make_Is_Trans() { return  new fiacre.strategy.transition.Is_Trans();}private static  tom.library.sl.Strategy  tom_make_Is_AND() { return  new fiacre.strategy.infix.Is_AND();}private static  tom.library.sl.Strategy  tom_make_Is_OR() { return  new fiacre.strategy.infix.Is_OR();}private static  tom.library.sl.Strategy  tom_make_Is_LE() { return  new fiacre.strategy.infix.Is_LE();}private static  tom.library.sl.Strategy  tom_make_Is_LT() { return  new fiacre.strategy.infix.Is_LT();}private static  tom.library.sl.Strategy  tom_make_Is_GT() { return  new fiacre.strategy.infix.Is_GT();}private static  tom.library.sl.Strategy  tom_make_Is_GE() { return  new fiacre.strategy.infix.Is_GE();}private static  tom.library.sl.Strategy  tom_make_Is_EQ() { return  new fiacre.strategy.infix.Is_EQ();}private static  tom.library.sl.Strategy  tom_make_Is_NE() { return  new fiacre.strategy.infix.Is_NE();}private static  tom.library.sl.Strategy  tom_make_Is_ADD() { return  new fiacre.strategy.infix.Is_ADD();}private static  tom.library.sl.Strategy  tom_make_Is_SUB() { return  new fiacre.strategy.infix.Is_SUB();}private static  tom.library.sl.Strategy  tom_make_Is_MOD() { return  new fiacre.strategy.infix.Is_MOD();}private static  tom.library.sl.Strategy  tom_make_Is_MUL() { return  new fiacre.strategy.infix.Is_MUL();}private static  tom.library.sl.Strategy  tom_make_Is_DIV() { return  new fiacre.strategy.infix.Is_DIV();}private static  tom.library.sl.Strategy  tom_make_Is_caseElement() { return  new fiacre.strategy.caseelement.Is_caseElement();}   


	public static Program_Fiacre extendedProcess (Program_Fiacre prg) throws Exception {
		try {
			processes = tom_empty_list_DeclarationList() ;
			prg = tom_make_TopDown(tom_make_elimExtProc()).visit (prg) ;
			{{if (tom_is_sort_Program_Fiacre(((Object)prg))) {if (tom_is_sort_Program_Fiacre((( fiacre.types.Program_Fiacre )((Object)prg)))) {if (tom_is_fun_sym_Prog((( fiacre.types.Program_Fiacre )(( fiacre.types.Program_Fiacre )((Object)prg))))) { fiacre.types.Declarations  tomMatch1_2=tom_get_slot_Prog_decl((( fiacre.types.Program_Fiacre )((Object)prg)));if (tom_is_fun_sym_DeclarationList((( fiacre.types.Declarations )tomMatch1_2))) {if (tom_is_sort_Declarations(((Object)processes))) {if (tom_is_fun_sym_DeclarationList((( fiacre.types.Declarations )(( fiacre.types.Declarations )((Object)processes))))) {

					return tom_make_Prog(tom_append_list_DeclarationList((( fiacre.types.Declarations )((Object)processes)),tom_append_list_DeclarationList(tomMatch1_2,tom_empty_list_DeclarationList())),tom_get_slot_Prog_main((( fiacre.types.Program_Fiacre )((Object)prg)))) ;
				}}}}}}}}

		} 
		catch (VisitFailure e) {
		}
		return prg ;
	}

	public static class elimExtProc extends tom.library.sl.AbstractStrategyBasic {public elimExtProc() {super(tom_make_Identity());}public tom.library.sl.Visitable[] getChildren() {tom.library.sl.Visitable[] stratChilds = new tom.library.sl.Visitable[getChildCount()];stratChilds[0] = super.getChildAt(0);return stratChilds;}public tom.library.sl.Visitable setChildren(tom.library.sl.Visitable[] children) {super.setChildAt(0, children[0]);return this;}public int getChildCount() {return 1;}public tom.library.sl.Visitable getChildAt(int index) {switch (index) {case 0: return super.getChildAt(0);default: throw new IndexOutOfBoundsException();}}public tom.library.sl.Visitable setChildAt(int index, tom.library.sl.Visitable child) {switch (index) {case 0: return super.setChildAt(0, child);default: throw new IndexOutOfBoundsException();}}@SuppressWarnings("unchecked")public <T> T visitLight(T v, tom.library.sl.Introspector introspector) throws tom.library.sl.VisitFailure {if (tom_is_sort_Declaration(v)) {return ((T)visit_Declaration((( fiacre.types.Declaration )v),introspector));}if (!(( null  == environment))) {return ((T)any.visit(environment,introspector));} else {return any.visitLight(v,introspector);}}@SuppressWarnings("unchecked")public  fiacre.types.Declaration  _visit_Declaration( fiacre.types.Declaration  arg, tom.library.sl.Introspector introspector) throws tom.library.sl.VisitFailure {if (!(( null  == environment))) {return (( fiacre.types.Declaration )any.visit(environment,introspector));} else {return any.visitLight(arg,introspector);}}@SuppressWarnings("unchecked")public  fiacre.types.Declaration  visit_Declaration( fiacre.types.Declaration  tom__arg, tom.library.sl.Introspector introspector) throws tom.library.sl.VisitFailure {{{if (tom_is_sort_Declaration(((Object)tom__arg))) {if (tom_is_sort_Declaration((( fiacre.types.Declaration )((Object)tom__arg)))) {if (tom_is_fun_sym_ExtendedProcessDecl((( fiacre.types.Declaration )(( fiacre.types.Declaration )((Object)tom__arg))))) { String  tom_name=tom_get_slot_ExtendedProcessDecl_name((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.StringList  tom_genericParams=tom_get_slot_ExtendedProcessDecl_genericParams((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.PortDecls  tom_ports=tom_get_slot_ExtendedProcessDecl_ports((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.ParamDecls  tom_params=tom_get_slot_ExtendedProcessDecl_params((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.LPDList  tom_lpd=tom_get_slot_ExtendedProcessDecl_lpd((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.PrioDeclList  tom_prios=tom_get_slot_ExtendedProcessDecl_prios((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.StringList  tom_states=tom_get_slot_ExtendedProcessDecl_states((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.VarDecls  tom_vars=tom_get_slot_ExtendedProcessDecl_vars((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.Init  tom_init=tom_get_slot_ExtendedProcessDecl_init((( fiacre.types.Declaration )((Object)tom__arg))); fiacre.types.Transitions  tom_trans=tom_get_slot_ExtendedProcessDecl_trans((( fiacre.types.Declaration )((Object)tom__arg)));


				if (tom_lpd!= tom_empty_list_lpdList() || tom_prios!= tom_empty_list_PrioList()) {
					Declaration proc = tom_make_ProcessDecl("gextendedProcess_" + tom_name,tom_genericParams,genProcessPortsDecls(tom_ports,tom_lpd),tom_params,tom_states,tom_vars,tom_init,tom_trans) ;
					processes = tom_make_ConsDeclarationList(proc,processes) ;
					return tom_make_ComponentDecl(tom_name,tom_genericParams,tom_ports,tom_params,tom_empty_list_ListVarDecl(),tom_lpd,tom_prios,tom_make_NoneInit(),tom_make_ParComp(tom_make_parCompo(tom_make_AllPorts(),tom_cons_list_PCList(tom_make_PortComp(tom_make_SomePorts(tom_empty_list_listExp()),tom_make_InstanceComp(tom_make_Inst("gextendedProcess_" + tom_name,tom_empty_list_GenInstList(),genProcessPorts(tom_ports,tom_lpd),genProcessParams(tom_params)))),tom_empty_list_PCList())))) ;
				} else {
					return tom_make_ProcessDecl(tom_name,tom_genericParams,tom_ports,tom_params,tom_states,tom_vars,tom_init,tom_trans) ;
				}
			}}}}}return _visit_Declaration(tom__arg,introspector);}}private static  tom.library.sl.Strategy  tom_make_elimExtProc() { return new elimExtProc();}



	private static PortDecls genProcessPortsDecls (PortDecls decls, LPDList loc) {
		{{if (tom_is_sort_LPDList(((Object)loc))) {if (tom_is_sort_LPDList((( fiacre.types.LPDList )((Object)loc)))) {if (tom_is_fun_sym_ConslpdList((( fiacre.types.LPDList )(( fiacre.types.LPDList )((Object)loc))))) { fiacre.types.LocPortDecl  tomMatch3_1=tom_get_slot_ConslpdList_HeadlpdList((( fiacre.types.LPDList )((Object)loc)));if (tom_is_sort_LocPortDecl(tomMatch3_1)) {if (tom_is_fun_sym_LocPortDec((( fiacre.types.LocPortDecl )tomMatch3_1))) {

				return concPortDecls (tom_get_slot_LocPortDec_pdl(tomMatch3_1), genProcessPortsDecls (decls, tom_get_slot_ConslpdList_TaillpdList((( fiacre.types.LPDList )((Object)loc))))) ;
			}}}}}}}

		return decls ;
	}

	private static ExpList genProcessPorts (PortDecls decls, LPDList loc) {
		{{if (tom_is_sort_LPDList(((Object)loc))) {if (tom_is_sort_LPDList((( fiacre.types.LPDList )((Object)loc)))) {if (tom_is_fun_sym_ConslpdList((( fiacre.types.LPDList )(( fiacre.types.LPDList )((Object)loc))))) { fiacre.types.LocPortDecl  tomMatch4_1=tom_get_slot_ConslpdList_HeadlpdList((( fiacre.types.LPDList )((Object)loc)));if (tom_is_sort_LocPortDecl(tomMatch4_1)) {if (tom_is_fun_sym_LocPortDec((( fiacre.types.LocPortDecl )tomMatch4_1))) {

				return concExpList (portDeclsToExpList (tom_get_slot_LocPortDec_pdl(tomMatch4_1)), genProcessPorts (decls, tom_get_slot_ConslpdList_TaillpdList((( fiacre.types.LPDList )((Object)loc))))) ;
			}}}}}}}

		return portDeclsToExpList (decls) ;
	}

	private static ExpList genProcessParams (ParamDecls params) {
		{{if (tom_is_sort_ParamDecls(((Object)params))) {if (tom_is_sort_ParamDecls((( fiacre.types.ParamDecls )((Object)params)))) {if (tom_is_fun_sym_ConsListParamDecl((( fiacre.types.ParamDecls )(( fiacre.types.ParamDecls )((Object)params))))) { fiacre.types.ParamDecl  tomMatch5_1=tom_get_slot_ConsListParamDecl_HeadListParamDecl((( fiacre.types.ParamDecls )((Object)params)));if (tom_is_sort_ParamDecl(tomMatch5_1)) {if (tom_is_fun_sym_Paramdec((( fiacre.types.ParamDecl )tomMatch5_1))) {

				return concExpList (argListToExplist (tom_get_slot_Paramdec_lal(tomMatch5_1)), genProcessParams (tom_get_slot_ConsListParamDecl_TailListParamDecl((( fiacre.types.ParamDecls )((Object)params))))) ;
			}}}}}}}

		return tom_empty_list_listExp() ;
	}

	private static ExpList portDeclsToExpList (PortDecls decls) {
		{{if (tom_is_sort_PortDecls(((Object)decls))) {if (tom_is_sort_PortDecls((( fiacre.types.PortDecls )((Object)decls)))) {if (tom_is_fun_sym_ConsListPortDecl((( fiacre.types.PortDecls )(( fiacre.types.PortDecls )((Object)decls))))) { fiacre.types.PortDecl  tomMatch6_1=tom_get_slot_ConsListPortDecl_HeadListPortDecl((( fiacre.types.PortDecls )((Object)decls)));if (tom_is_sort_PortDecl(tomMatch6_1)) {if (tom_is_fun_sym_PortDec((( fiacre.types.PortDecl )tomMatch6_1))) {

				return concExpList (stringListToExplist (tom_get_slot_PortDec_lp(tomMatch6_1)), portDeclsToExpList (tom_get_slot_ConsListPortDecl_TailListPortDecl((( fiacre.types.PortDecls )((Object)decls))))) ;
			}}}}}}}

		return tom_empty_list_listExp() ;
	}

	private static ExpList argListToExplist (ArgList args) {
		{{if (tom_is_sort_ArgList(((Object)args))) {if (tom_is_sort_ArgList((( fiacre.types.ArgList )((Object)args)))) {if (tom_is_fun_sym_ConsArList((( fiacre.types.ArgList )(( fiacre.types.ArgList )((Object)args))))) { fiacre.types.Arg  tomMatch7_1=tom_get_slot_ConsArList_HeadArList((( fiacre.types.ArgList )((Object)args)));if (tom_is_sort_Arg(tomMatch7_1)) {if (tom_is_fun_sym_ValArg((( fiacre.types.Arg )tomMatch7_1))) {

				return tom_make_ConslistExp(tom_make_IdentExp(tom_get_slot_ValArg_arg(tomMatch7_1),tom_make_OpenKind(),tom_make_BotType()),argListToExplist(tom_get_slot_ConsArList_TailArList((( fiacre.types.ArgList )((Object)args))))) ;
			}}}}}}{if (tom_is_sort_ArgList(((Object)args))) {if (tom_is_sort_ArgList((( fiacre.types.ArgList )((Object)args)))) {if (tom_is_fun_sym_ConsArList((( fiacre.types.ArgList )(( fiacre.types.ArgList )((Object)args))))) { fiacre.types.Arg  tomMatch7_9=tom_get_slot_ConsArList_HeadArList((( fiacre.types.ArgList )((Object)args)));if (tom_is_sort_Arg(tomMatch7_9)) {if (tom_is_fun_sym_RefArg((( fiacre.types.Arg )tomMatch7_9))) {

				return tom_make_ConslistExp(tom_make_RefExp(tom_get_slot_RefArg_arg(tomMatch7_9),tom_make_BotType()),argListToExplist(tom_get_slot_ConsArList_TailArList((( fiacre.types.ArgList )((Object)args))))) ;
			}}}}}}}

		return tom_empty_list_listExp() ;
	}

	private static ExpList stringListToExplist (StringList lst) {
		{{if (tom_is_sort_StringList(((Object)lst))) {if (tom_is_sort_StringList((( fiacre.types.StringList )((Object)lst)))) {if (tom_is_fun_sym_ConsstringList((( fiacre.types.StringList )(( fiacre.types.StringList )((Object)lst))))) {

				return tom_make_ConslistExp(tom_make_IdentExp(tom_get_slot_ConsstringList_HeadstringList((( fiacre.types.StringList )((Object)lst))),tom_make_OpenKind(),tom_make_BotType()),stringListToExplist(tom_get_slot_ConsstringList_TailstringList((( fiacre.types.StringList )((Object)lst))))) ;
			}}}}}

		return tom_empty_list_listExp() ;
	}

	private static ExpList concExpList (ExpList e1, ExpList e2) {
		{{if (tom_is_sort_ExpList(((Object)e1))) {if (tom_is_fun_sym_listExp((( fiacre.types.ExpList )(( fiacre.types.ExpList )((Object)e1))))) {if (tom_is_sort_ExpList(((Object)e2))) {if (tom_is_fun_sym_listExp((( fiacre.types.ExpList )(( fiacre.types.ExpList )((Object)e2))))) {

				return tom_append_list_listExp((( fiacre.types.ExpList )((Object)e1)),tom_append_list_listExp((( fiacre.types.ExpList )((Object)e2)),tom_empty_list_listExp())) ;
			}}}}}}

		return tom_empty_list_listExp() ;
	}

	private static PortDecls concPortDecls (PortDecls d1, PortDecls d2) {
		{{if (tom_is_sort_PortDecls(((Object)d1))) {if (tom_is_fun_sym_ListPortDecl((( fiacre.types.PortDecls )(( fiacre.types.PortDecls )((Object)d1))))) {if (tom_is_sort_PortDecls(((Object)d2))) {if (tom_is_fun_sym_ListPortDecl((( fiacre.types.PortDecls )(( fiacre.types.PortDecls )((Object)d2))))) {

				return tom_append_list_ListPortDecl((( fiacre.types.PortDecls )((Object)d1)),tom_append_list_ListPortDecl((( fiacre.types.PortDecls )((Object)d2)),tom_empty_list_ListPortDecl())) ;
			}}}}}}

		return tom_empty_list_ListPortDecl() ;
	}

	private static Declarations processes = tom_empty_list_DeclarationList() ;
}
